\section{Backlog Management}
How do we manage our backlog in an agile environment. There often is the mythos that in agile there is no real planning. This for sure is a myth. Planning in agile occurs over the hole project and may even be more than in a waterfall project. The main focus should always be the customer: when can we show the new feature to the customer?

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{agilemythos}
  \caption{No Planning in Agile is a Myth}
\end{figure}


\subsection{Basics}
In this section we defined the basics in regard the of the backlog management.

\subsubsection{Common Planning levels in Scrum}
We have differente levels of planing in Scrum: Epics, User Stories and Tasks. First the epics are defined and in the iteration process the smaller user stories and tasks are defined. With every level the level of detail gets greater. While the Epics are defined by the product owner, the tasks are defined the developer team. The conversion of epics to users stories happens most of the time in the sprint planning or the refinement meeting.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{scrumlevels}
  \caption{Scrum Item Levels}
\end{figure}

In the following model we visualise the use of the backlog. The Backlog is orderd by priorisation of the items. The higher an item is, the more likely it is realised in the next iteration. These user stories are taken and we make tasks for the development team.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{productbacklog}
  \caption{Backlog Management in Scrum}
\end{figure}

\subsubsection{Epics}
Is a very rough description of something that might be needed somewhen in the future. It is about tracking and idea, it allows priorization and estimation. The epics may be written by anyone involved in the process, but the priorization is up to the PO.

\subsubsection{User Stories}
\begin{minipage}{0.5\textwidth}
An informal, natural language description from the perspective of the user. Most details are omitted because time consuming specification should be delayed.	 Important details might be added to a suer story as acceptance criteria. Often recorded on index cards to foster direct communication. May be written by anyone involved in the process is up to the PO.
\end{minipage}
\begin{minipage}{0.5\textwidth}
	\centering
	\includegraphics[width=0.75\linewidth]{userstory}
\end{minipage}

Over time the details of a user story should be evolved. Often teams use post-it cards to manage the user stories physically. The reason for this is that they have to keep the stories as short as possible.

\begin{figure}[hbt]
  \center
  \includegraphics[width=0.75\textwidth]{userstoriesdetails}
  \caption{User Stories Level of Detail over Time}
\end{figure}

\subsubsection{Tasks}
Tasks are the work items we learned about in the lecture about project planning. Tasks are typically written by the development team as part of the sprint planning. A task is only created when it's 100\% sure that the belonging user story is required. There might be tasks in a sprint backlog that are not directly related to a user story. 

\subsubsection{Refinement Meeting}
 The goal of the refinement meeting is to refine the product backlog with the whole scrum team. The team does everything that is needed to keep the backlog  in a good shape: present and discuss new ideas, break down epics into user stories, break down user stories into tasks, estimate and prioritise, remove no longer needed items. This is not an official scrum event, but highly recommended.
 
\subsubsection{Story Maps}
A story map does enable a team in the first phase to create a product backlog. The team arranges epics and user stories in to independent dimensions: sort by activity horizontally, sort by priority vertically. Is also very useful for release planning, as it fosters discussion about the functionality of the MVP. Can also be used to create an initial backlog, starting from top-down.

\begin{figure}[hbt]
  \center
  \includegraphics[width=0.5\textwidth]{storymap}
  \caption{Story Map to create a Backlog}
\end{figure}
 
\subsubsection{Release Planning}
For release planning in agile projects, two things are needed: estimates for all required functionality, velocity of the team. The estimates can be made in refinements and the velocity is best measured in iterations.

Velocity can be measured only after executing some iterations. On the other hand, many companies want a release plan early in the project. Most of the time, the best option is to do some iterations and measure progress, but there are alternatives: historical data, blind estimation.

\subsection{Priorization}
\begin{quote}
	There will always be more to do than time money will allow. - anyone
\end{quote}

We have to prioritise in order to balance the quality triangle and to make sure the request features get realised first.

\subsubsection{MVP Approach}
All the features for the MVP have the highest priority. You can extend this to planning multiple releases - every release has its own priority. This is a nice example for applying the "Pareto Principle" - 20\% effort for 80\% result.

\subsubsection{Other Factors}
\begin{minipage}{0.5\textwidth}
	In general, other factors used for priorization are different for every scrum project. In Scrum it is. a main task of the product owner to choose the right factors. Possible factors for every feature are: Financial, Cost of developing a new feature, new knowledge generated by the feature, amount of risks removed by the feature, desirability of the feature.
\end{minipage}
\begin{minipage}{0.5\textwidth}
	\centering\includegraphics[width=0.8\textwidth]{factors}
\end{minipage}

\subsubsection{Kano Model}
\begin{minipage}{0.5\textwidth}
	\textbf{Threshold Attributes (Must-Be)}
	\begin{itemize}
		\itemsep -0.2em
  		\item Basic feature that the customer expect
  		\item Having a lot increases satisfaction only slightly
	\end{itemize}	
	
	\textbf{Performance Attributes (1-Dimensional)}
	\begin{itemize}
		\itemsep -0.2em
		\item Not necessary, but welcome to the customer
		\item Linear increases in customer statisfaction
	\end{itemize}
	
	\textbf{Excitement Attribute}
	\begin{itemize}
		\itemsep -0.2em
		\item Surprise the customer
		\item Huge impact on the customer statisfaction
	\end{itemize}
\end{minipage}
\begin{minipage}{0.5\textwidth}
	\includegraphics[width=0.8\textwidth]{kanomodel}
\end{minipage}

\subsubsection{MoSCoW Method}
\begin{description}
  \item[Must Have]
  \item[Should Have]
  \item[Could Have]
  \item[Would Have]
\end{description}

\subsubsection{The Big Wall}
An approach developed by Mitch Lacey for prioritizing and estimating a big backlog .

\begin{enumerate}
	\item Developers horizontally sort all items by their relative size 
	\item Business owners vertically sort all items by their priority
\end{enumerate}

\subsection{Estimation}
\begin{quote}
	«Prediction is very difficult, especially about the future.» - Niels Bor, Danish physicist
\end{quote}

Estimation is hard and we all know that. In most software projects, you must estimate something you never built before. Requirements change and as a result, your estimate will as well. Most of the time the software developers focus on coding and forget about the rest. Software is developed in teams, where every individual has different qualities. Investing more time into estimation will not increase its accuracy all the time! 

\subsubsection{Agile Estimation}
Agile teams not only plan on different levels - they also estimates on different levels.
\begin{itemize}
	\itemsep -0.2em
	\item \textbf{Rough Estimates} are used for Epics
	\item \textbf{Improved Estimates} are used for User Stories
	\item \textbf{Elaborate Estimates} are used for Tasks
\end{itemize}

Estimates improve over time, based on existing feedback cycles.  Estimates are given by the people that will perform the task ("ask the experts"). Estimation is done by the whole team and estimation is therefore about communication in the team. 

\subsubsection{Absolute and Relative}
People are best at estimating things that fall within one order of magnitude.  Means: we are pretty good at estimating things relatively, but not absolutely.  Corner stone of agile planning: stories are sized relatively to each other. Typically, a mid-sized reference story is used for relative sizing (aka Golden Story). Based on actual feedback (velocity), some accurate predictions can be made.

\paragraph{Units} \hfill \\
The concrete unit you use for estimation is secondary – given it is relative. Teams new to Agile often stick to hour-based estimates because it feels more real.  Other teams intentionally get rid of any time terms to emphasise relative sizing: story points, t-shirt sizes, fruits.

\paragraph{Scales} \hfill \\
You know the problem: too many options to choose from makes taking decision harder. To fasten things up, allowed values are limited to a predefined set for estimation. Commonly used scales are: normal, fibonacci, fingers, t-shirt.
  

\subsubsection{Planning Poker}
Is way to agree on the estimation of different user stories in the team. This "game" avoids the influence of other participants and emphasises the discussions about the requirements. There is also good tool support available for this game.

\begin{enumerate}
	\itemsep -0.2em
	\item Each estimator is given a deck of cards
	\item PO reads a story and team discusses it briefly
	\item Each estimator selects a card representing his/her estimate
	\item Cards are turned over so all can see them
	\item Discuss differences
	\item Re-estimate until estimates converge 
\end{enumerate}

\subsubsection{Timeboxing}
As you might have noticed, Scrum uses timeboxes for all Scrum events. The sprints are limited to 1 to 4 weeks and meetings are limited to a maximum of four hours. Timeboxes can also be used, if estimates are impossible.  Estimate the effort it takes to create a prototype, spike or tracer bullet. Use the time to gather all the knowledge required to give a more elaborate estimate.

\paragraph{Short-term Estimation}
While preparing the next iteration, break down user stories into tasks and estimate them. For iteration planning, it is fine to use ideal hours. Calculate the available ideal hours in the iteration and compare the sum of your estimates against it. Track the efforts you invested into your tasks to make your future estimates more accurate.

\subsubsection{Mathematic Models}
In the pre-agile days, there were also mathematic models for effort estimation: COCOMO, Function Points, PERT. Basic idea: categorize your system based on different criteria and apply formulas to calculate an estimate. While these models would be nice candidates for exam questions, I don’t see much practical use for them nowadays.
 
\begin{figure}[h!]
  \center
  \includegraphics[width=0.8\textwidth]{estimates}
  \caption{Estimates are not Commitments!}
\end{figure}

 
 



